// 2004-12-18 programmeerimisvistlus
// lesanne: LENNUREIS (algajate rhm)
// Autor: Mihkel Kree
// Testitud: GCC 3.2 / MinGW, VC 6.0 / Win32

#include <fstream>
#include <sstream>
#include <vector>
#include <string>
using namespace std;

typedef struct lennu_info{
	int algus;  // lennu algushetk alates peva algusest minutites (loeme failist)
	int lopp;   // lennu lpphetk loetuna antud peva algusest minutites (loeme failist)
	int kestus; // lennu kestus minutites
}lennu_info;

// lendude aegu hoiame 'vectorites'
vector<lennu_info> lennudAB, lennudBC;

// teisendab kellaja kujul hh:mm minutiteks
int teisenda_minuteiks(string s){
	int tunnid=0;
	int minutid=0;

	int ind=0;
	while (s[ind]!=':'){
		tunnid*=10;
		tunnid+=s[ind]-'0';
		ind++;
	}

	ind++;
	while (ind<s.size()){
		minutid*=10;
		minutid+=s[ind]-'0';
		ind++;
	}

	return tunnid*60+minutid;
}

// lisab antud lennu kohta kiva kirje 'vectorisse'
void lisa(string s1, string s2, vector<lennu_info> &lennud){
	int a=teisenda_minuteiks(s1);
	int b=teisenda_minuteiks(s2);

	// lennu kestus
	int c=b-a;
	// kas lennatakse ka keskl?
	if (c<=0) c+=24*60;

	lennu_info abi;
	abi.algus=a;
	abi.lopp=b;
	abi.kestus=c;

	lennud.push_back(abi);
}

void loe_andmed(){
	ifstream sis("areis.sis");

	int n;
	sis >> n;

	int i;
	for (i=0; i<n; i++){
		string s1,s2;
		sis >> s1 >> s2;
		lisa(s1,s2,lennudAB);
	}

	sis >> n;
	for (i=0; i<n; i++){
		string s1,s2;
		sis >> s1 >> s2;
		lisa(s1,s2,lennudBC);
	}
}

// leiab ajakulu marsruudil, mis kasutab lende i ja j
int leia_aeg(int i, int j){
	// linnas B veedetav aeg:
	int b=lennudBC[j].algus - lennudAB[i].lopp;
	// kas peame  linnas B veetma?
	while (b<30) b+=24*60;

	return b+lennudAB[i].kestus+lennudBC[j].kestus;
}

int parimaeg=1000000000;  //parima reisi kogukestus
// parimasse marsruuti kuuluvate lendude indeksid
int indAB;
int indBC;

void leia_parim_reis(){
	for (int i=0; i<lennudAB.size(); i++)
		for (int j=0; j<lennudBC.size(); j++){
			int aeg=leia_aeg(i,j);
			if (aeg<parimaeg){
				parimaeg=aeg;
				indAB=i;
				indBC=j;
			}
		}
}

// teisendab minutites antud kellaja kujule hh:mm
string tee_string(int min){
	ostringstream os;
	os << min/60 << ":";
	if (min%60<10) os << "0";
	os << min%60;

	return os.str();
}

int main(){
	loe_andmed();
	leia_parim_reis();

	// kirjutame tulemuse faili
	ofstream val("areis.val");
	val << tee_string(lennudAB[indAB].algus) << " " << tee_string(lennudAB[indAB].lopp) << endl;
	val << tee_string(lennudBC[indBC].algus) << " " << tee_string(lennudBC[indBC].lopp) << endl;

	return 0;
}
