{ 2004-12-18 programmeerimisvistlus                                        }
{ lesanne: LENNUREIS (algajate rhm)                                       }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
   sisf = 'AREIS.SIS';                                   { sisendfaili nimi }
   valf = 'AREIS.VAL';                                  { vljundfaili nimi }
   maxn = 100;                             { maksimaalne lendude arv liinil }
   minv = 30;                           { minimaalne ajavaru mberistumisel }

type
   lend = record                                               { lennu info }
      v : integer;                { vljumisaeg, minutites peva algusest }
      s : integer;                { saabumisaeg, minutites peva algusest }
   end;

var
   n1, n2 : integer;                                     { lende A-B ja B-C }
   a1, a2 : array [1..maxn] of lend;                       { lendude andmed }
   l1, l2 : integer;                                       { valitud lennud }

procedure dekodeeri_aeg(s : string; var a : integer);
var t, m, i, u : integer;
begin
   i := pos(':', s);
   val(copy(s, 1, i - 1), t, u);
   val(copy(s, i + 1, length(s) - i), m, u);
   a := 60 * t + m;
end;

procedure dekodeeri_lend(s : string; var k : lend);
var i : integer;
begin
   i := pos(' ', s);
   dekodeeri_aeg(copy(s, 1, i - 1), k.v);
   dekodeeri_aeg(copy(s, i + 1, length(s) - i), k.s);
end;

procedure loe_sisend;
var f : text; i : integer; s : string;
begin
   assign(f, sisf); reset(f);
   readln(f, n1);
   for i := 1 to n1 do begin
      readln(f, s); dekodeeri_lend(s, a1[i]);
   end;
   readln(f, n2);
   for i := 1 to n2 do begin
      readln(f, s); dekodeeri_lend(s, a2[i]);
   end;
   close(f);
end;

procedure leia_parim_lend;
var i1, i2, ap, ax : integer;
begin
   ap := maxint;
   for i1 := 1 to n1 do
      for i2 := 1 to n2 do begin
         ax := 0;
         while a1[i1].s + minv > a2[i2].v + ax do
            ax := ax + 24 * 60;
         if a1[i1].v >= a1[i1].s then
            ax := ax + 24 * 60;
         if a2[i2].v >= a2[i2].s then
            ax := ax + 24 * 60;
         if a2[i2].s - a1[i1].v + ax < ap then begin
            ap := a2[i2].s - a1[i1].v + ax; l1 := i1; l2 := i2;
         end;
      end;
end;

procedure tee_aeg(var f : text; a : integer);
var t, m : integer;
begin
   t := a div 60;
   m := a mod 60;
   if m < 10 then
      write(f, t, ':0', m)
   else
      write(f, t, ':', m);
end;

procedure tee_lend(var f : text; var k : lend);
begin
   tee_aeg(f, k.v);
   write(f, ' ');
   tee_aeg(f, k.s);
   writeln(f);
end;

procedure tee_valjund;
var f : text;
begin
   assign(f, valf); rewrite(f);
   tee_lend(f, a1[l1]);
   tee_lend(f, a2[l2]);
   close(f);
end;

begin
   loe_sisend;
   leia_parim_lend;
   tee_valjund;
end.
