{ 2004-12-18 programmeerimisvistlus                                        }
{ lesanne: SIRGLIK (edasijudnute rhm)                                   }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

{ Tpne lahend analtiliselt. }

const
   sisf = 'ELOIK.SIS';                                   { sisendfaili nimi }
   valf = 'ELOIK.VAL';                                  { vljundfaili nimi }

var
   xa, ya, xb, yb : real;                  { ligu otspunktide koordinaadid }
   xr, yr, r : real;             { ringi keskpunkti koordinaadid ja raadius }
   l : real;                                               { otsitav pikkus }

procedure loe_sisend;
var f : text;
begin
   assign(f, sisf); reset(f);
   readln(f, xa, ya);
   readln(f, xb, yb);
   readln(f, xr, yr, r);
   close(f);
end;

{ punktide (x1, y1) ja (x2, y2) vaheline kaugus }
function kaugus(x1, y1, x2, y2 : real) : real;
begin
   kaugus := sqrt(sqr(x2 - x1) + sqr(y2 - y1));
end;

{ kas punkt (x, y) on ringi sees }
function sees(x, y : real) : boolean;
begin
   sees := kaugus(x, y, xr, yr) <= r;
end;

{ lahendab ruutvrrandi; tagastab true, kui on reaalarvulised lahendid }
function lahenda_rv(a, b, c : real; var t1, t2 : real) : boolean;
var d : real;
begin
   if a = 0 then begin
      { pole ruutvrrand; see juhtub ainult siis, kui ligu pikkus on 0 }
      lahenda_rv := false;
      exit;
   end;
   d := sqr(b) - 4 * a * c;
   if d < 0 then begin
      { determinant negatiivne, lahendid puuduvad }
      lahenda_rv := false;
      exit;
   end;
   lahenda_rv := true;
   t1 := (-b - sqrt(d)) / (2 * a);
   t2 := (-b + sqrt(d)) / (2 * a);
end;

{ leiab sirge ja ringjoone likepunktid; tagastab true, kui likuvad }
function leia_lp(var x1, y1, x2, y2 : real) : boolean;
var u, v, a, b, c, t : real;
begin
   if xa = xb then begin
      if ya = yb then begin
         leia_lp := false;
         exit;
      end;
      { vahetame x- ja y-telje }
      t := xa; xa := ya; ya := t;
      t := xb; xb := yb; yb := t;
      t := xr; xr := yr; yr := t;
   end;
   { sirge vrrandi kordajad }
   u := (ya - yb) / (xa - xb);
   v := ya - xa * u;
   { ruutvrrandi kordajad }
   a := sqr(u) + 1;
   b := - 2 * (xr - u * (v - yr));
   c := sqr(xr) + sqr(v - yr) - sqr(r);
   { lahendame ruutvrrandi }
   if not lahenda_rv(a, b, c, x1, x2) then begin
      leia_lp := false;
      exit;
   end;
   leia_lp := true;
   y1 := x1 * u + v;
   y2 := x2 * u + v;
end;

{ leiab otsitava ligu pikkuse }
procedure leia_pikkus;
var x1, y1, x2, y2 : real;
begin
   if leia_lp(x1, y1, x2, y2) then begin
      if not sees(xa, ya) then
         if kaugus(xa, ya, x1, y1) < kaugus(xa, ya, x2, y2) then begin
            xa := x1; ya := y1;
         end else begin
            xa := x2; ya := y2;
         end;
      if not sees(xb, yb) then
         if kaugus(xb, yb, x1, y1) < kaugus(xb, yb, x2, y2) then begin
            xb := x1; yb := y1;
         end else begin
            xb := x2; yb := y2;
         end;
      l := kaugus(xa, ya, xb, yb);
   end else
      l := 0;
end;

procedure tee_valjund;
var f : text;
begin
   assign(f, valf); rewrite(f);
   writeln(f, l);
   close(f);
end;

begin
   loe_sisend;
   leia_pikkus;
   tee_valjund;
end.
