{ 2004-12-18 programmeerimisvistlus                                        }
{ lesanne: SIRGLIK (edasijudnute rhm)                                   }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

{ Ligikaudne lahend kahendotsimise abil. }

const
   sisf = 'ELOIK.SIS';                                   { sisendfaili nimi }
   valf = 'ELOIK.VAL';                                  { vljundfaili nimi }
   null = 1e-6;                       { kik, mis alla selle, loeme nulliks }

var
   xa, ya, xb, yb : real;                  { ligu otspunktide koordinaadid }
   xr, yr, r : real;             { ringi keskpunkti koordinaadid ja raadius }
   l : real;                                               { otsitav pikkus }

procedure loe_sisend;
var f : text;
begin
   assign(f, sisf); reset(f);
   readln(f, xa, ya);
   readln(f, xb, yb);
   readln(f, xr, yr, r);
   close(f);
end;

{ punktide (x1, y1) ja (x2, y2) vaheline kaugus }
function kaugus(x1, y1, x2, y2 : real) : real;
begin
   kaugus := sqrt(sqr(x2 - x1) + sqr(y2 - y1));
end;

{ kas punkt (x, y) on ringi sees }
function sees(x, y : real) : boolean;
begin
   sees := kaugus(x, y, xr, yr) <= r;
end;

{ leiab ligu ja ringjoone likepunkti }
{ eeldab, et (x1, y1) on ringi sees ja (x2, y2) ringist vljas }
procedure leia_lp(x1, y1, x2, y2 : real; var x, y : real);
begin
   repeat
      { leiame ligu keskpunkti }
      x := (x1 + x2) / 2; y := (y1 + y2) / 2;
      { kui see on ringi sees, asendame sisemise otspunkti, muidu vlimise }
      if sees(x, y) then begin
         x1 := x; y1 := y;
      end else begin
         x2 := x; y2 := y;
      end;
   until kaugus(x1, y1, x2, y2) <= null;
end;

{ leiab ligul ringi sees oleva punkti; tagastab true, kui leidis }
function leia_sp(x1, y1, x2, y2 : real; var x, y : real) : boolean;
begin
   repeat
      { leiame ligu keskpunkti }
      x := (x1 + x2) / 2; y := (y1 + y2) / 2;
      { kui see on ringi sees, lpetame otsimise }
      if sees(x, y) then begin
         leia_sp := true;
         exit;
      end;
      { asendame kaugema otspunkti keskpunktiga }
      if kaugus(x1, y1, xr, yr) > kaugus(x2, y2, xr, yr) then begin
         x1 := x; y1 := y;
      end else begin
         x2 := x; y2 := y;
      end;
   until kaugus(x1, y1, x2, y2) <= null;
   { ei leidnudki sisepunkti }
   leia_sp := false;
end;

{ leiab otsitava ligu pikkuse }
procedure leia_pikkus;
var x, y : real;
begin
   if sees(xa, ya) and sees(xb, yb) then begin
      { kui terve lik on ringi sees, on vastus ligu pikkus }
      l := kaugus(xa, ya, xb, yb);
      exit;
   end;
   if sees(xa, ya) and not sees(xb, yb) then begin
      { kui ks otspunkt on ringi sees, asendame teise likepunktiga }
      leia_lp(xa, ya, xb, yb, xb, yb);
      l := kaugus(xa, ya, xb, yb);
      exit;
   end;
   if not sees(xa, ya) and sees(xb, yb) then begin
      { kui ks otspunkt on ringi sees, asendame teise likepunktiga }
      leia_lp(xb, yb, xa, ya, xa, ya);
      l := kaugus(xb, yb, xa, ya);
      exit;
   end;
   if not sees(xa, ya) and not sees(xb, yb) then
      if leia_sp(xa, ya, xb, yb, x, y) then begin
         { leiame ligul he ringi sees oleva punkti }
         { siis taandame mlemad otspunktid selle abil likepunktideks }
         leia_lp(x, y, xa, ya, xa, ya);
         leia_lp(x, y, xb, yb, xb, yb);
         l := kaugus(xa, ya, xb, yb);
         exit;
      end;
   l := 0
end;

procedure tee_valjund;
var f : text;
begin
   assign(f, valf); rewrite(f);
   writeln(f, l :0:5);     { mistliku tpsuse mrab konstant null eelpool }
   close(f);
end;

begin
   loe_sisend;
   leia_pikkus;
   tee_valjund;
end.
