// 2004-12-18 programmeerimisvistlus
// lesanne: LENNUREIS (edasijudnute rhm)
// Autor: Mihkel Kree
// Testitud: GCC 3.2 / MinGW, VC 6.0 / Win32

#include <fstream>
#include <sstream>
#include <vector>
#include <string>
using namespace std;

char p2ev[]={'E','T','K','N','R','L','P'};

typedef struct lennu_info{
	int mis_p2ev; // n2dalap2eva indeks (alustame loendamist nullist)
	int algus;    // lennu algushetk alates peva algusest minutites (loeme failist)
	int lopp;     // lennu lpphetk loetuna peva algusest minutites (loeme failist)
	int kestus;   // lennu kestus minutites
}lennu_info;

// lendude aegu hoiame 'vectorites'
vector<lennu_info> lennudAB, lennudBC;

// teisendab kellaja kujul hh:mm minutiteks
int teisenda_minuteiks(string s){
	int tunnid=0;
	int minutid=0;

	int ind=0;
	while (s[ind]!=':'){
		tunnid*=10;
		tunnid+=s[ind]-'0';
		ind++;
	}

	ind++;
	while (ind<s.size()){
		minutid*=10;
		minutid+=s[ind]-'0';
		ind++;
	}

	return tunnid*60+minutid;
}

// lisab antud lennu kohta kivad kirjed 'vectorisse'
void lisa(string s1, string s2, string p2evad, vector<lennu_info> &lennud){
	int a=teisenda_minuteiks(s1);
	int b=teisenda_minuteiks(s2);

	// lennu kestus
	int c=b-a;
	// kas lennatakse ka keskl?
	if (c<=0) c+=24*60;

	lennu_info abi;
	abi.algus=a;
	abi.lopp=b;
	abi.kestus=c;

	// iga ndalapeva kohta, mil lennatakse, tuleb ks kirje 'vectorisse'
	for (int i=0; i<p2evad.size(); i++){
		for (int j=0; j<7; j++) if (p2ev[j]==p2evad[i]) abi.mis_p2ev=j;
		lennud.push_back(abi);
	}
}

void loe_andmed(){
	ifstream sis("ereis.sis");

	int n;
	sis >> n;

	int i;
	for (i=0; i<n; i++){
		string s1,s2,s3;
		sis >> s1 >> s2 >> s3;
		lisa(s1,s2,s3,lennudAB);
	}

	sis >> n;
	for (i=0; i<n; i++){
		string s1,s2,s3;
		sis >> s1 >> s2 >> s3;
		lisa(s1,s2,s3,lennudBC);
	}
}

// leiab ajakulu marsruudil, mis kasutab lende i ja j
int leia_aeg(int i, int j){

	// linna B judmise aeg alates ndala algusest:
	int saabum=lennudAB[i].mis_p2ev*24*60 + lennudAB[i].algus + lennudAB[i].kestus;

	// linnast B lahkumise aeg alates ndala algusest:
	int lahkum=lennudBC[j].mis_p2ev*24*60 + lennudBC[j].algus;

	int vahe=lahkum-saabum;

	// kas phapeva sda tuleb linnas B veeta?
	while (vahe<30) vahe+=7*24*60;

	return vahe+lennudAB[i].kestus+lennudBC[j].kestus;
}

int parimaeg=1000000000; //parima reisi kogukestus
// parimasse marsruuti kuuluvate lendude indeksid
int indAB; 
int indBC;

void leia_parim_reis(){
	for (int i=0; i<lennudAB.size(); i++)
		for (int j=0; j<lennudBC.size(); j++){
			int aeg=leia_aeg(i,j);
			if (aeg<parimaeg){
				parimaeg=aeg;
				indAB=i;
				indBC=j;
			}
		}
}

// teisendab minutites antud kellaja kujule hh:mm
string tee_string(int min){
	ostringstream os;
	os << min/60 << ":";
	if (min%60<10) os << "0";
	os << min%60;

	return os.str();
}

int main(){
	loe_andmed();
	leia_parim_reis();

	// kirjutame tulemuse faili
	ofstream val("ereis.val");
	val << tee_string(lennudAB[indAB].algus) << " "
		<< tee_string(lennudAB[indAB].lopp) << " " << p2ev[lennudAB[indAB].mis_p2ev] << endl;

	val << tee_string(lennudBC[indBC].algus) << " "
		<< tee_string(lennudBC[indBC].lopp) << " " << p2ev[lennudBC[indBC].mis_p2ev] << endl;

	return 0;
}
