{ 2004-12-18 programmeerimisvistlus                                        }
{ lesanne: LENNUREIS (edasijudnute rhm)                                  }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
   sisf = 'EREIS.SIS';                                   { sisendfaili nimi }
   valf = 'EREIS.VAL';                                  { vljundfaili nimi }
   maxn = 100;                             { maksimaalne lendude arv liinil }
   minv = 30;                           { minimaalne ajavaru mberistumisel }
   paev : string = 'ETKNRLPETKNRLPETKNRLPETKNRLP';  { ndalapevade thised }

type
   lend = record                                               { lennu info }
      v : integer;                 { vljumisaeg, minutites ndala algusest }
      s : integer;                 { saabumisaeg, minutites ndala algusest }
   end;

var
   n1, n2 : integer;                                     { lende A-B ja B-C }
   k1, k2 : integer;                     { lahtikirjutatud lende A-B ja B-C }
   a : array [1..maxn*7*2] of lend;                        { lendude andmed }
   l1, l2 : integer;                                       { valitud lennud }

procedure dekodeeri_aeg(s : string; var a : integer);
var t, m, i, u : integer;
begin
   i := pos(':', s);
   val(copy(s, 1, i - 1), t, u);
   val(copy(s, i + 1, length(s) - i), m, u);
   a := 60 * t + m;
end;

procedure dekodeeri_lend(s : string; n : integer; var k : integer);
var a1, a2, i1, i2, j : integer;
begin
   i1 := pos(' ', s);
   dekodeeri_aeg(copy(s, 1, i1 - 1), a1);
   i2 := pos(' ', copy(s, i1 + 1, length(s) - i1));
   dekodeeri_aeg(copy(s, i1 + 1, i2 - 1), a2);
   if a2 <= a1 then
      a2 := a2 + 60 * 24;
   for j := i1 + i2 + 1 to length(s) do begin
      k := k + 1;
      a[n + k].v := a1 + pos(s[j], paev) * 60 * 24;
      a[n + k].s := a2 + pos(s[j], paev) * 60 * 24;
   end;
end;

procedure loe_sisend;
var f : text; i : integer; s : string;
begin
   assign(f, sisf); reset(f);
   readln(f, n1); k1 := 0;
   for i := 1 to n1 do begin
      readln(f, s); dekodeeri_lend(s, 0, k1);
   end;
   readln(f, n2); k2 := 0;
   for i := 1 to n2 do begin
      readln(f, s); dekodeeri_lend(s, k1, k2);
   end;
   close(f);
end;

procedure leia_parim_lend;
var i1, i2, ax, ap : integer;
begin
   ap := maxint;
   for i1 := 1 to k1 do
      for i2 := k1 + 1 to k1 + k2 do begin
         ax := 0;
         while a[i1].s + minv > a[i2].v + ax do
            ax := ax + 60 * 24 * 7;
         ax := ax + a[i2].s - a[i1].v;
         if ax < ap then begin
            ap := ax; l1 := i1; l2 := i2;
         end;
      end;
end;

procedure tee_aeg(var f : text; a : integer);
var t, m : integer;
begin
   t := a div 60 mod 24;
   m := a mod 60;
   if m < 10 then
      write(f, t, ':0', m)
   else
      write(f, t, ':', m);
end;

procedure tee_lend(var f : text; l : integer);
begin
   tee_aeg(f, a[l].v); write(f, ' ');
   tee_aeg(f, a[l].s); write(f, ' ');
   writeln(f, paev[a[l].v div 60 div 24]);
end;

procedure tee_valjund;
var f : text;
begin
   assign(f, valf); rewrite(f);
   tee_lend(f, l1);
   tee_lend(f, l2);
   close(f);
end;

begin
   loe_sisend;
   leia_parim_lend;
   tee_valjund;
end.
